//
// UCSD p-System cross compiler
// Copyright (C) 2010, 2012 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// you option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program. If not, see <http://www.gnu.org/licenses/>
//

#include <lib/type/integer.h>

#include <ucsdpsys_assemble/expression/dereference/asm.h>


expression_dereference_asm::~expression_dereference_asm()
{
}


expression_dereference_asm::expression_dereference_asm(
    const expression::pointer &a_operand
) :
    expression_dereference(a_operand)
{
}


expression_dereference_asm::pointer
expression_dereference_asm::create(const expression::pointer &a_operand)
{
    return pointer(new expression_dereference_asm(a_operand));
}


type::pointer
expression_dereference_asm::get_type(void)
    const
{
    return type_integer::create();
}


expression::pointer
expression_dereference_asm::clone(const location &locn)
    const
{
    return create(get_operand()->clone(locn));
}


expression::pointer
expression_dereference_asm::optimize(void)
    const
{
    return create(get_operand()->optimize());
}


// vim: set ts=8 sw=4 et :
